Last Comment Bug 650228 - Lag when redrawing text whose opacity is changed when also animating height
: Lag when redrawing text whose opacity is changed when also animating height
Status: VERIFIED FIXED
[regression from retained layers]
: regression
Product: Core
Classification: Components
Component: Layout (show other bugs)
: Trunk
: All All
: -- normal (vote)
: mozilla6
Assigned To: Robert O'Callahan (:roc) (Exited; email my personal email if necessary)
:
Mentors:
http://jsfiddle.net/Mh29G/3/
Depends on:
Blocks: 564991
  Show dependency treegraph
 
Reported: 2011-04-15 03:06 PDT by wheresrhys
Modified: 2011-05-31 08:44 PDT (History)
12 users (show)
mounir: in‑testsuite+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
-
fixed


Attachments
Reduced testcase (631 bytes, text/html)
2011-04-19 16:19 PDT, Robert O'Callahan (:roc) (Exited; email my personal email if necessary)
no flags Details
fix (4.48 KB, patch)
2011-04-19 17:15 PDT, Robert O'Callahan (:roc) (Exited; email my personal email if necessary)
dbaron: review+
asa: approval‑mozilla‑aurora+
dveditz: approval‑mozilla‑beta+
Details | Diff | Splinter Review

Description wheresrhys 2011-04-15 03:06:20 PDT
User-Agent:       Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0) Gecko/20100101 Firefox/4.0
Build Identifier: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0) Gecko/20100101 Firefox/4.0

When changing opacity and animating height at the same time position of text is only adjusted at the end of teh animation.

(Sort of duplicates this bug: https://bugzilla.mozilla.org/show_bug.cgi?id=616914)

Reproducible: Always

Steps to Reproduce:
1. Go to http://jsfiddle.net/Mh29G/3/
2. click on the top item in the accordion
3. observe teh misdrawing of text in the bottom two items
Actual Results:  
Text stays in exact same position, gets hidden by the moving containers, and then is redrawn in the correct position at the end of the animation

Expected Results:  
Text moves down with its containing block
Comment 1 Alice0775 White 2011-04-15 03:28:08 PDT
Confirmed on
http://hg.mozilla.org/mozilla-central/rev/aa200a803e07
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:6.0a1) Gecko/20110414 Firefox/6.0a1 ID:20110414030535

*It happens regardless of hardware acceleration.
*And also happens Firefox4.0 and Aurora5.0a2.
*Not happens of Firefox3.6.16.
Comment 2 Alice0775 White 2011-04-15 03:46:20 PDT
Regression window(cached m-c hourly):
Works:
http://hg.mozilla.org/mozilla-central/rev/92339b84d089
Mozilla/5.0 (Windows; Windows NT 6.1; WOW64; en-US; rv:2.0b2pre) Gecko/20100715 Minefield/4.0b2pre ID:20100715145415
Fails:
http://hg.mozilla.org/mozilla-central/rev/e1d7fd5255fd
Mozilla/5.0 (Windows; Windows NT 6.1; WOW64; en-US; rv:2.0b2pre) Gecko/20100715 Minefield/4.0b2pre ID:20100715152722
Pushlog:
http://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=92339b84d089&tochange=e1d7fd5255fd
Comment 3 David Baron :dbaron: ⌚️UTC+2 (review requests must explain patch) 2011-04-15 15:25:36 PDT
I see this on Linux as well.  Seems pretty bad for a layers bug.
Comment 4 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-18 21:51:52 PDT
This is a subtle one. Saving the "Result" frame to a file doesn't show the bug, nor does saving the entire jsfiddle page :-(
Comment 5 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-18 21:53:46 PDT
Also, doing the test more than once doesn't show the bug. I have to reload the page to get the bug to show again.
Comment 6 Alice0775 White 2011-04-18 21:59:38 PDT
(In reply to comment #4)
> This is a subtle one. Saving the "Result" frame to a file doesn't show the bug,
> nor does saving the entire jsfiddle page :-(

Umm, I can reproduce with the following str.
[str]
1 Open the Saved  one("Result" frame).
2 Click 1st row
3 Click 3rd row
4 Click 1st row
Comment 7 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-18 22:04:09 PDT
Ah, I can reproduce a related bug on a local copy.

Sorry Alice --- I'm not as fast as you :-).
Comment 8 Johnny Stenback (:jst, jst@mozilla.com) 2011-04-19 15:41:59 PDT
Not tracking for 5, but if there's a safe fix for this in time for beta please nominate the patch.
Comment 9 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-19 16:19:32 PDT
Created attachment 527142 [details]
Reduced testcase
Comment 10 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-19 17:15:02 PDT
Created attachment 527158 [details] [diff] [review]
fix
Comment 11 David Baron :dbaron: ⌚️UTC+2 (review requests must explain patch) 2011-04-19 17:23:48 PDT
Comment on attachment 527158 [details] [diff] [review]
fix

r=dbaron
Comment 12 David Baron :dbaron: ⌚️UTC+2 (review requests must explain patch) 2011-04-19 17:24:37 PDT
(Did you check that the reftest fails without the patch?)
Comment 13 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-04-19 19:07:41 PDT
Yes.
Comment 14 Mounir Lamouri (:mounir) 2011-05-13 02:11:50 PDT
Pushed:
http://hg.mozilla.org/mozilla-central/rev/6bd8239e3434
Comment 15 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-05-16 03:09:47 PDT
Comment on attachment 527158 [details] [diff] [review]
fix

This is a fairly bad regression in Firefox 4. The patch is very safe, it just causes more invalidation.
Comment 16 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-05-22 18:24:40 PDT
http://hg.mozilla.org/releases/mozilla-aurora/rev/7d4b05121ada
Comment 17 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-05-22 18:25:28 PDT
Comment on attachment 527158 [details] [diff] [review]
fix

This is a fairly bad regression in Firefox 4. The patch is very safe, it just causes more invalidation.
Comment 18 Daniel Veditz [:dveditz] 2011-05-23 15:25:11 PDT
Comment on attachment 527158 [details] [diff] [review]
fix

Approved for the mozilla-beta repository, a=dveditz for release-drivers
Comment 19 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-05-23 18:08:30 PDT
http://hg.mozilla.org/releases/mozilla-beta/rev/91d9c8c72dd2
Comment 20 Simona B [:simonab] 2011-05-31 08:44:31 PDT
Mozilla/5.0 (Windows NT 6.1; rv:5.0) Gecko/20100101 Firefox/5.0

Verified the issue using the STR from Comment 6 on Win XP, Win 7, Mac OS X 10.6, Ubuntu x86, Ubuntu x86_64.

Note You need to log in before you can comment on or make changes to this bug.